"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

function _pluginSyntaxOptionalCatchBinding() {
  var data = _interopRequireDefault(require("@babel/plugin-syntax-optional-catch-binding"));

  _pluginSyntaxOptionalCatchBinding = function _pluginSyntaxOptionalCatchBinding() {
    return data;
  };

  return data;
}

function _core() {
  var data = require("@babel/core");

  _core = function _core() {
    return data;
  };

  return data;
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _default() {
  return {
    inherits: _pluginSyntaxOptionalCatchBinding().default,
    visitor: {
      CatchClause: function CatchClause(path) {
        if (path.node.param === null || !_core().types.isIdentifier(path.node.param)) {
          return;
        }

        var binding = path.scope.getOwnBinding(path.node.param.name);

        if (binding.constantViolations.length > 0) {
          return;
        }

        if (!binding.referenced) {
          var paramPath = path.get("param");
          paramPath.remove();
        }
      }
    }
  };
}